<script setup lang="ts">
    import { WritableComputedRef, computed, ref } from 'vue'

    interface Props {
        modelValue: Array<string> | undefined
        label: string
        formatHelp: string
        dataCy: string
    }

    const props = defineProps<Props>()

    const emit = defineEmits<{
        'update:modelValue': [value: Array<string>]
    }>()

    const getArrayOfStringToStringAndSetArrayOfString: WritableComputedRef<
        string | undefined
    > = computed({
        get() {
            return props.modelValue?.join('\n') ?? ''
        },
        set(value: string | undefined) {
            emit(
                'update:modelValue',
                value
                    ? value.split('\n').filter((string) => string.length > 0)
                    : []
            )
        },
    })

    const showFormatHelp = ref(false)
    const toggleFormatHelp = () => {
        showFormatHelp.value = !showFormatHelp.value
    }
</script>

<template>
    <v-alert
        v-if="showFormatHelp"
        variant="outlined"
        border="start"
        class="mb-6"
        icon="mdi-help-circle-outline"
        title="Exemple de saisie"
    >
        <code
            style="
                white-space: pre;
                display: block;
                margin: 0.5em;
                padding: 0.8em;
                overflow-x: auto;
                background-color: rgb(231, 231, 231);
                border-radius: 10px;
            "
            >{{ props.formatHelp }}</code
        >
        <p>Saisissez chaque élément séparé d'un retour-chariot</p>
    </v-alert>

    <v-textarea
        v-model="getArrayOfStringToStringAndSetArrayOfString"
        :label="label"
        variant="outlined"
        class="mb-3"
        :data-cy="dataCy"
        hide-details="auto"
        :append-inner-icon="
            showFormatHelp ? 'mdi-close' : 'mdi-help-circle-outline'
        "
        v-bind="$attrs"
        auto-grow
        @click:append-inner="toggleFormatHelp"
    />
</template>
